-- PARTIE 1b : Conception BD
-- Julien Maître
-- Paul Narbonneau

-- Raisonner avec l'algèbre relationnelle
-- Exo 1 :
/*
Le résultat des étudiants en cours de math ({Toto,A}, {Lulu, B})
Enseignement sans résultat (null)
Résultat sans enseignant (null)
Etudiant qui a eu la même note à tous les cours(Toto)
Le nom des profs des cours auxquels Toto a eu A (Martin, Dupont)
*/

-- Exo 2 :
/*
R |><| S = PROJ {R.X, R.Y, S.Z} (REST { R.X = S.X } (R >< S))
R |>< S = PROJ {R.X, R.Y} (REST { R.X = S.X } (R >< S))
R |> S = R - R |>< S
R =|><| S = R |><| S UNION ((R |> S) >< {S.X=null, S.Z=null})
R =|><|= S =
            R |><| S
    UNION ((R |> S) >< {S.X=null, S.Z=null})
    UNION ({R.X=null, R.Y=null} >< (S |> R))

R / T = PROJ {R.Y} (
            PROJ {R.X, R.Y} (
                R |>< T                                                On prend toutes les jointures
                -                                                      On retire :
                REST {R.X != R.Y}                                      Les tuples qui ne match pas => pour lesquelles il manque 1 jointure
                    R >< T                                             Produit cartésien
                )
            )
        )
*/

-- Exo 3 :

-- Q1
SELECT
    NomCli
FROM
    CLI
WHERE
    Pays LIKE "FRANCE";

-- Q2
SELECT
    NomCli
FROM
    CLI
WHERE
    Pays LIKE "FRANCE"
OR
    Pays LIKE "ANGLETERRE"

-- Q3
SELECT
    PROD.*
FROM
    PROD,
    DET,
    COM,
    CLI
WHERE
    CLI.CodeCli = COM.CodeCli
AND
    COM.NumCom = DET.NumCom
AND
    DET.NumProd = PROD.NumProd
AND
    CLI.NomCli LIKE "Antonio"

-- Q4
    SELECT
        FOU.*
    FROM
        FOU,
        PROD
    WHERE
        FOU.NumFou = PROD.NumFou
    AND
        PROD.prix < 50
INTERSECT
    SELECT
        FOU.*
    FROM
        FOU,
        PROD
    WHERE
        FOU.NumFou = PROD.NumFou
    AND
        PROD.prix > 400;

-- Q5
SELECT DISTINCT
    CLI.*
FROM
    CLI,
    COM
WHERE
    CLI.NumCli = COM.NumCli
AND (
        COM.AnCom = 1992
    OR
        COM.AnCom = 1993
);

-- Q6
SELECT
    *
FROM
    FOU
WHERE
    FOU.NomFou IN (
        SELECT
            NomCli
        FROM
            CLI
    )

-- Q7
SELECT
    *
FROM
    FOU
WHERE
    NOT EXIST (
        SELECT
            *
        FROM
            PROD
        WHERE
            PROD.NumFou = FOU.NumFou
        AND
            PROD.Prix > 50
    )

SELECT
    *
FROM
    FOU
WHERE
    NumFou NOT IN (
        SELECT
            NumFou
        FROM
            PROD
        WHERE
            Prix > 50
    )

-- Q8
SELECT
    *
FROM
    FOU
WHERE
    NumFou NOT IN (
        SELECT
            NumFou
        FROM
            PROD
        WHERE
            Prix < 50
    )

-- Q9


-- Q10
SELECT
    *
FROM
    CLI
WHERE
    NOT EXIST (
        SELECT
            *
        FROM
            COM
        WHERE
            COM.NumCli = CLI.NumCli
    )
